/**
 * version:		$Id: vpl-xmlrpc-jail.cpp,v 1.2 2009/07/29 00:02:42 juanca Exp $
 * package:		Part of vpl-xmlrpc-jail
 * copyright:	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * license:		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 **/

/**
 * Deamon vpl-xmlrpc-jail. jail for vpl using xmlrpc
 **/

#if HAVE_CONFIG_H
#include <config.h>
#endif

#include "jail.h"
#include "util.h"

using namespace std;

/**
 * main accept command line [-d level] [-uri URI]
 * where level is the syslog log level and URI is the xmlrpc server uri
 */
int main(int const argc, const char ** const argv, char * const * const env) {
	openlog("vpl-xmlrpc-jail",LOG_PID,LOG_USER);
	//Set log level from command arg "-d level"
	string debugLevel=Util::getCommand(argc,argv,"-d");
	if(debugLevel.size()>0){
		setlogmask(LOG_UPTO(atoi(debugLevel.c_str())));
		syslog(LOG_INFO,"Set log mask up to %s",debugLevel.c_str());
	}else{
		setlogmask(LOG_UPTO(LOG_ERR));
	}
	try{
		Jail jail(argc,argv,env);
		jail.process();
	}
	catch(const char * const me){
		syslog(LOG_ERR,"%s",me);
	}
	catch(...){
		syslog(LOG_ERR,"unexpected exception");
	}
	return 0;
}
